This is an interesting idea and from the looks of it well executed, but I am having trouble imagining a scenario were I would prefer to use Amber over a scripting language like Python. If your bash scripts are getting long enough to warrant the use of Amber you are probably already in a situation where you can justify installing Python.
post
I didnt realize it could go to different bash versions.
That could actually be really handy for me, write once and out for the versions I need...
When do you need a newer or older version of Bash to target? I mean usually this is not a thing to concern about.
Client systems outside of my control.
It is not usually a thing to be concerned about. It is something I end up having to be concerned about though.
Interesting. There is this example in the docs:
let result = $ cat file.txt | grep "READY" $ failed {
echo "Failed to read the file"
}
https://docs.amber-lang.com/basic_syntax/commands
How can we know for sure what failed here? Was it the cat or the grep? My instinct says the pipe returns the code of the last cmd or failure, which could be either.
Perhaps it's just a contrived example and it would be better to separate testing file existence from grepping in real code...
Yep, the code you provided is compiled into this:
command_0="$(cat file.txt | grep "READY")"
__status=$?
if [ "${__status}" != 0 ]; then
echo "Failed to read the file"
fi
So, the outcome would depend on the pipefail option. (set -o pipefail)
As you suggested, an Amberic snippet would be:
import { file_read } from "std/fs"
import { match_regex } from "std/text"
const result = file_read("file.txt") failed {
echo "Failed to read the file"
}
if match_regex(result, "READY"):
echo "file.txt contains READY"
I'm reminded of the horrid example showcased on the amber-lang website previously.

They know you can just do if ((age < 18)) in bash, right?
Or rather if ((10#$age < 18)) because age=021 would not be adult 😉 Hopefully, they protect against that at least.
(I had to double-check this stupid default is still a thing, since I moved to zsh many years ago.)
[ "$age" \< 18 ] && {
echo "I'm not an adult yet"
} || {
echo "I'm an adult"
}
if you want to be using braces in if statements lol
Currently, Amber does not even support Bash 2 because Bash 2 does not support the += operator. (ticket) However, I believe that POSIX compliance is on Amber's long-term milestone, and that it will eventually achieve this as its support range expands.
As someone who knows nothing about POSIX, what's the difference or in your opinion what would make it specifically better with the context of amber?
I've been writing POSIX scripts as a sort of hobby and don't really have any Bash experience but I think I can still give some insight. Hopefully what I say is accurate but this is what I've learned so far.
POSIX is a standard, to say it as simple as possible, it sets the minimum requirements for environment, programs, commands and options for those commands with the purpose of having those commands be as portable as possible. That way a POSIX script will work on any POSIX compliant system. For example a POSIX script could work on Arch, Debian, on a Raspberry Pi or even Mac products. In theory if could work on windows too. If an Operating System ships with a POSIX compliant shell, you are very likely able to run a POSIX script.
Bash is a shell but it has a bunch of features that expand beyond the basic features set by the POSIX standard. Bash also has more features and flexibility for scripting which is why it's so common to see Bash scripts. Those scripting features are usually referred to as "bashisms." Since it expands on POSIX scripting, it can look similar to a POSIX script but would not work as intended if you ran a Bash script outside of a Bash shell.
With a lot of modern OS's, they would likely have Bash installed and you most likely don't need to worry about anything. However, Bash is not a standard and not required to be installed on every system.
If you care about your script working on as many systems as possible without the worry about what shell is being used, you will probably prefer writing a sh shell, POSIX compliant script.
Since POSIX shells and scripts work on a much more basic level, it can lack some depth and finding work arounds for issues can start to look unreadable/insane. A good example is how arrays are handled. POSIX is limited to one array where Bash has much better support for arrays.
There are advantages to using either but with the popularity of Bash, it's not really that big of a deal in the end.
tbh, I wouldn't recommend that during alpha staging. There are still many bugs.
My most recent Bash mistake was misusing test -n and test -z. In Amber, I can just use something == "" or len(something) == 0
test -n can be [ "$something" ] and test -z can be [ "$something" = "" ]
And this applies to posix shell, not just bash.
I just installed fish shell a few years ago. Best scripting language I've come across. No need to remember all this weird bash syntax you have to look up every time you want to use it. All of fish shell fits in your working memory, seriously. It's tiny.
Fish is my main shell of choice and I use my self-written functions(https://github.com/lens0021/Lens0021_Personal.Fish/blob/main/conf.d/lens0021_personal.fish) daily. But it is hard for me to say Fish's syntax is not weird. Especially, I'm a little fuzzy on how to use argparse. I am sorry.
In which way is it weird? It's different, but how is it weird?
No need to apologize, you're allowed your opinions and feelings.
I would suggest reading the manual page for argparse thoroughly from top to bottom of you haven't already. I struggled with argparse at first too, but it's because I skimmed the manual instead of reading it.
I would also read through all of the manual, and you'll find useful idiomatic fish things like not setting PATH directly, but using fish_add_path, among other things. 👍

all 39 comments